# bug-triage -- bug triage and forward tool.
# Copyright (C) 2007  Gustavo R. Montesino
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

import pygtk
pygtk.require("2.0")
import gtk

from exceptions import *

response_OK = 1
response_CANCEL = 0

class dlg_qbuilder:
    """Query builder dialog related callbacks and functions"""

    def __init__(self, xml):
        self.xml = xml
        self.dialog = xml.get_widget("dlg_qbuilder")
        
        self.cb_mainfield = xml.get_widget("cb_mainfield")
        self.cb_mainfield.set_active(0)

        self.entry_mainvalue = xml.get_widget("entry_mainvalue")
        self.entry_mainvalue.set_text("")
    
    def get(self):
        """Returns the current query"""

        if self.cb_mainfield.get_active() == 0: # Bug Number
            return "bug: %s" % self.entry_mainvalue.get_text()

        elif self.cb_mainfield.get_active() == 1: # Souce Package
            return "src: %s" % self.entry_mainvalue.get_text()

        elif self.cb_mainfield.get_active() == 2: # Package
            return "pkg: %s" % self.entry_mainvalue.get_text()

        elif self.cb_mainfield.get_active() == 3: # Maintainer
            return "maint: %s" % self.entry_mainvalue.get_text()

        elif self.cb_mainfield.get_active() == 4: # Submitter
            return "from: %s" % self.entry_mainvalue.get_text()

        else:
            raise InvalidQueryError
    
    def run(self):
        """Show the dialog

        Shows the dialog to the user, and return a string representation
        of the choosen query or None if the user cancels."""

        response = self.dialog.run()
        self.dialog.hide()

        if response == response_OK:
            return self.get()
        else:
            return None
        
# vim: tabstop=4 expandtab shiftwidth=4
