import pygtk
pygtk.require("2.0")
import gtk

from btsutils import debbugs

import actions
from bug_store import bug_store
from bug_view import bug_view
from dlg_qbuilder import dlg_qbuilder

class win_main:
    """Callback functions for the main window"""

    def __init__(self, ui_xml):
        """Initializes the class

        ui_xml should be the glade.XML ui representation"""
        self.xml = ui_xml

        self.tv_bugs = bug_view(self.xml)
        self.xml.signal_autoconnect(self.tv_bugs)

        self.entry_query = self.xml.get_widget("entry_query")

        self.tb_show = self.xml.get_widget("tb_show")
        self.tb_show.set_sensitive(False)

        mi_show = self.xml.get_widget("menuitem_show")
        mi_show.set_sensitive(False)

    def quit(self, object, event=None, data=None):
        gtk.main_quit()
    
    def query(self, object=None):
        """Callback for query button click

        Runs the query on the query entry and show the result in
        the tree view"""

        bugs = debbugs.query(self.entry_query.get_text())

        model = bug_store()
        for i in bugs:
            model.append(i)

        self.tv_bugs.set_model(model)

    def query_new(self, object):
        dialog = dlg_qbuilder(self.xml)
        query = dialog.run()
        if query:
            self.entry_query.set_text(query)
            self.query()

    def show(self, object):
        """Callback to show/got button click"""

        bugs = self.tv_bugs.get_selection()
        for bug in bugs:
            actions.show(bug.getBug())

# vim: tabstop=4 expandtab shiftwidth=4
